<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::avs::MessageRequest Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html">avs</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html">MessageRequest</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::avs::MessageRequest Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_message_request_8h_source.html">MessageRequest.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::avs::MessageRequest:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1acl_1_1test_1_1_mock_message_request.html" title="alexaClientSDK::acl\l::test::MockMessageRequest" alt="" coords="273,5,466,44"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1capability_agents_1_1do_not_disturb_1_1_d_n_d_message_request.html" title="alexaClientSDK::capability\lAgents::doNotDisturb::DNDMessage\lRequest" alt="" coords="250,68,489,120"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1capability_agents_1_1playback_controller_1_1_playback_message_request.html" title="alexaClientSDK::capability\lAgents::playbackController\l::PlaybackMessageRequest" alt="" coords="276,144,463,196"/>
<area shape="rect" id="node5" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html" title="alexaClientSDK::integration\l::ObservableMessageRequest" alt="" coords="269,220,470,259"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_1_1_named_reader.html">NamedReader</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">A struct to hold an <code>AttachmentReader</code> alongside its name.  <a href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_1_1_named_reader.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a74d6eb572d6c3f1172cfa5108fcd5a64"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a74d6eb572d6c3f1172cfa5108fcd5a64">MessageRequest</a> (const std::string &amp;jsonContent, const std::string &amp;uriPathExtension=&quot;&quot;)</td></tr>
<tr class="separator:a74d6eb572d6c3f1172cfa5108fcd5a64"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a62d7ec22c5c11079faec9f1a7a834a"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a8a62d7ec22c5c11079faec9f1a7a834a">~MessageRequest</a> ()</td></tr>
<tr class="separator:a8a62d7ec22c5c11079faec9f1a7a834a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7f6ff7cc1d2b684a16ea33e706b5600e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a7f6ff7cc1d2b684a16ea33e706b5600e">addAttachmentReader</a> (const std::string &amp;name, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_reader.html">attachment::AttachmentReader</a> &gt; attachmentReader)</td></tr>
<tr class="separator:a7f6ff7cc1d2b684a16ea33e706b5600e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2e3df68ead7a256b7c617cc98abb9d6"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#ae2e3df68ead7a256b7c617cc98abb9d6">getJsonContent</a> ()</td></tr>
<tr class="separator:ae2e3df68ead7a256b7c617cc98abb9d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab0cb8cc3cdd1e5094eff0776ad54d518"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#ab0cb8cc3cdd1e5094eff0776ad54d518">getUriPathExtension</a> ()</td></tr>
<tr class="separator:ab0cb8cc3cdd1e5094eff0776ad54d518"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeee198a7b81ca9606891bc78a559490a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#aeee198a7b81ca9606891bc78a559490a">attachmentReadersCount</a> ()</td></tr>
<tr class="separator:aeee198a7b81ca9606891bc78a559490a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6767e31d1960a086975471813345a86f"><td class="memItemLeft" align="right" valign="top">std::shared_ptr&lt; <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_1_1_named_reader.html">NamedReader</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a6767e31d1960a086975471813345a86f">getAttachmentReader</a> (size_t index)</td></tr>
<tr class="separator:a6767e31d1960a086975471813345a86f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef0f5892c16d12f22d74011c92047be9"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#aef0f5892c16d12f22d74011c92047be9">sendCompleted</a> (<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a> status)</td></tr>
<tr class="separator:aef0f5892c16d12f22d74011c92047be9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a54ed5e88d810b85fed9f07b54def8fd3"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a54ed5e88d810b85fed9f07b54def8fd3">exceptionReceived</a> (const std::string &amp;exceptionMessage)</td></tr>
<tr class="separator:a54ed5e88d810b85fed9f07b54def8fd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0a451c99ee5d47c639e89b668e7830f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#ad0a451c99ee5d47c639e89b668e7830f">addObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html">avsCommon::sdkInterfaces::MessageRequestObserverInterface</a> &gt; observer)</td></tr>
<tr class="separator:ad0a451c99ee5d47c639e89b668e7830f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a31fe3acc9b87911b14fb4a10d98d6dda"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a31fe3acc9b87911b14fb4a10d98d6dda">removeObserver</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html">avsCommon::sdkInterfaces::MessageRequestObserverInterface</a> &gt; observer)</td></tr>
<tr class="separator:a31fe3acc9b87911b14fb4a10d98d6dda"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a423d6a102e3d537ccb4b56d185a14bf8"><td class="memItemLeft" align="right" valign="top">std::mutex&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a423d6a102e3d537ccb4b56d185a14bf8">m_observerMutex</a></td></tr>
<tr class="memdesc:a423d6a102e3d537ccb4b56d185a14bf8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Mutex to guard access of m_observers.  <a href="#a423d6a102e3d537ccb4b56d185a14bf8">More...</a><br /></td></tr>
<tr class="separator:a423d6a102e3d537ccb4b56d185a14bf8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad67b78688c70a3a33e137ebb51f3bd39"><td class="memItemLeft" align="right" valign="top">std::unordered_set&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html">avsCommon::sdkInterfaces::MessageRequestObserverInterface</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#ad67b78688c70a3a33e137ebb51f3bd39">m_observers</a></td></tr>
<tr class="memdesc:ad67b78688c70a3a33e137ebb51f3bd39"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set of observers of MessageRequestObserverInterface.  <a href="#ad67b78688c70a3a33e137ebb51f3bd39">More...</a><br /></td></tr>
<tr class="separator:ad67b78688c70a3a33e137ebb51f3bd39"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7f042e8bce1352f1359b111e5c5355b"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#af7f042e8bce1352f1359b111e5c5355b">m_jsonContent</a></td></tr>
<tr class="memdesc:af7f042e8bce1352f1359b111e5c5355b"><td class="mdescLeft">&#160;</td><td class="mdescRight">The JSON content to be sent to AVS.  <a href="#af7f042e8bce1352f1359b111e5c5355b">More...</a><br /></td></tr>
<tr class="separator:af7f042e8bce1352f1359b111e5c5355b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a23cd79d5ac89983f17b6c1d90a8942bf"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a23cd79d5ac89983f17b6c1d90a8942bf">m_uriPathExtension</a></td></tr>
<tr class="memdesc:a23cd79d5ac89983f17b6c1d90a8942bf"><td class="mdescLeft">&#160;</td><td class="mdescRight">The path extension to be appended to the base URL when sending.  <a href="#a23cd79d5ac89983f17b6c1d90a8942bf">More...</a><br /></td></tr>
<tr class="separator:a23cd79d5ac89983f17b6c1d90a8942bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a057aa763160b1417dc31f93706fa5a8f"><td class="memItemLeft" align="right" valign="top">std::vector&lt; std::shared_ptr&lt; <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_1_1_named_reader.html">NamedReader</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request.html#a057aa763160b1417dc31f93706fa5a8f">m_readers</a></td></tr>
<tr class="memdesc:a057aa763160b1417dc31f93706fa5a8f"><td class="mdescLeft">&#160;</td><td class="mdescRight">The AttachmentReaders of the Attachments data to be sent to AVS.  <a href="#a057aa763160b1417dc31f93706fa5a8f">More...</a><br /></td></tr>
<tr class="separator:a057aa763160b1417dc31f93706fa5a8f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">This is a wrapper class which allows a client to send a Message to AVS, and be notified when the attempt to send the Message was completed. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a74d6eb572d6c3f1172cfa5108fcd5a64"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a74d6eb572d6c3f1172cfa5108fcd5a64">&#9670;&nbsp;</a></span>MessageRequest()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::avsCommon::avs::MessageRequest::MessageRequest </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>jsonContent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>uriPathExtension</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Constructor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">jsonContent</td><td>The message to be sent to AVS. </td></tr>
    <tr><td class="paramname">uriPathExtension</td><td>An optional uri path extension which will be appended to the base url of the AVS. endpoint. If not specified, the default AVS path extension should be used by the sender implementation. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a8a62d7ec22c5c11079faec9f1a7a834a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8a62d7ec22c5c11079faec9f1a7a834a">&#9670;&nbsp;</a></span>~MessageRequest()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::avsCommon::avs::MessageRequest::~MessageRequest </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a7f6ff7cc1d2b684a16ea33e706b5600e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7f6ff7cc1d2b684a16ea33e706b5600e">&#9670;&nbsp;</a></span>addAttachmentReader()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::avs::MessageRequest::addAttachmentReader </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_reader.html">attachment::AttachmentReader</a> &gt;&#160;</td>
          <td class="paramname"><em>attachmentReader</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Adds an attachment reader to the message. The attachment data will be the next part in the message to be sent to AVS. </p><dl class="section note"><dt>Note</dt><dd>: The order by which the message attachments sent to AVS is the one by which they have been added to it.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">name</td><td>The name of the message part containing the attachment data. </td></tr>
    <tr><td class="paramname">attachmentReader</td><td>The attachment data to be sent to AVS along with the message. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad0a451c99ee5d47c639e89b668e7830f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad0a451c99ee5d47c639e89b668e7830f">&#9670;&nbsp;</a></span>addObserver()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::avs::MessageRequest::addObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html">avsCommon::sdkInterfaces::MessageRequestObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Add observer of MessageRequestObserverInterface.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to be added to the set. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aeee198a7b81ca9606891bc78a559490a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeee198a7b81ca9606891bc78a559490a">&#9670;&nbsp;</a></span>attachmentReadersCount()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int alexaClientSDK::avsCommon::avs::MessageRequest::attachmentReadersCount </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Gets the number of <code>AttachmentReaders</code> in this message.</p>
<dl class="section return"><dt>Returns</dt><dd>The number of readers in this message. </dd></dl>

</div>
</div>
<a id="a54ed5e88d810b85fed9f07b54def8fd3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a54ed5e88d810b85fed9f07b54def8fd3">&#9670;&nbsp;</a></span>exceptionReceived()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::avs::MessageRequest::exceptionReceived </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>exceptionMessage</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This function will be called if AVS responds with an exception message to this message request being sent.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">exceptionMessage</td><td>The exception message. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html#a71d3cce299cdbf95b8c34464c6e53e11">alexaClientSDK::integration::ObservableMessageRequest</a>.</p>

</div>
</div>
<a id="a6767e31d1960a086975471813345a86f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6767e31d1960a086975471813345a86f">&#9670;&nbsp;</a></span>getAttachmentReader()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_1_1_named_reader.html">MessageRequest::NamedReader</a> &gt; alexaClientSDK::avsCommon::avs::MessageRequest::getAttachmentReader </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Retrieves the ith AttachmentReader in the message.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">index</td><td>The index of the <code>AttachmentReader</code> to retrieve. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code><a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_1_1_named_reader.html" title="A struct to hold an AttachmentReader alongside its name. ">NamedReader</a></code> of the ith attachment in the message. A null pointer is returned when <code>index</code> is out of bound. </dd></dl>

</div>
</div>
<a id="ae2e3df68ead7a256b7c617cc98abb9d6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae2e3df68ead7a256b7c617cc98abb9d6">&#9670;&nbsp;</a></span>getJsonContent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::avsCommon::avs::MessageRequest::getJsonContent </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Retrieves the JSON content to be sent to AVS.</p>
<dl class="section return"><dt>Returns</dt><dd>The JSON content to be sent to AVS. </dd></dl>

</div>
</div>
<a id="ab0cb8cc3cdd1e5094eff0776ad54d518"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab0cb8cc3cdd1e5094eff0776ad54d518">&#9670;&nbsp;</a></span>getUriPathExtension()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::avsCommon::avs::MessageRequest::getUriPathExtension </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Retrieves the path extension to be appended to the base URL when sending.</p>
<dl class="section return"><dt>Returns</dt><dd>The path extension to be appended to the base URL when sending. </dd></dl>

</div>
</div>
<a id="a31fe3acc9b87911b14fb4a10d98d6dda"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a31fe3acc9b87911b14fb4a10d98d6dda">&#9670;&nbsp;</a></span>removeObserver()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::avs::MessageRequest::removeObserver </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html">avsCommon::sdkInterfaces::MessageRequestObserverInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>observer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Remove observer of MessageRequestObserverInterface.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">observer</td><td>The observer to be removed from the set. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aef0f5892c16d12f22d74011c92047be9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aef0f5892c16d12f22d74011c92047be9">&#9670;&nbsp;</a></span>sendCompleted()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::avs::MessageRequest::sendCompleted </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html#a29e40517f71dfc83e3159a8f0f489d7b">avsCommon::sdkInterfaces::MessageRequestObserverInterface::Status</a>&#160;</td>
          <td class="paramname"><em>status</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This is called once the send request has completed. The status parameter indicates success or failure. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">status</td><td>Whether the send request succeeded or failed. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1playback_controller_1_1_playback_message_request.html#a30ddec50a46dc7e06f08b0a0bb898611">alexaClientSDK::capabilityAgents::playbackController::PlaybackMessageRequest</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1do_not_disturb_1_1_d_n_d_message_request.html#abaec0b5f39f5264c5e5501325028e163">alexaClientSDK::capabilityAgents::doNotDisturb::DNDMessageRequest</a>, and <a class="el" href="classalexa_client_s_d_k_1_1integration_1_1_observable_message_request.html#aac5887c4dea8cdc4de3ba71010e12d41">alexaClientSDK::integration::ObservableMessageRequest</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="af7f042e8bce1352f1359b111e5c5355b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af7f042e8bce1352f1359b111e5c5355b">&#9670;&nbsp;</a></span>m_jsonContent</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::avsCommon::avs::MessageRequest::m_jsonContent</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The JSON content to be sent to AVS. </p>

</div>
</div>
<a id="a423d6a102e3d537ccb4b56d185a14bf8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a423d6a102e3d537ccb4b56d185a14bf8">&#9670;&nbsp;</a></span>m_observerMutex</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::mutex alexaClientSDK::avsCommon::avs::MessageRequest::m_observerMutex</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Mutex to guard access of m_observers. </p>

</div>
</div>
<a id="ad67b78688c70a3a33e137ebb51f3bd39"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad67b78688c70a3a33e137ebb51f3bd39">&#9670;&nbsp;</a></span>m_observers</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unordered_set&lt;std::shared_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_message_request_observer_interface.html">avsCommon::sdkInterfaces::MessageRequestObserverInterface</a>&gt; &gt; alexaClientSDK::avsCommon::avs::MessageRequest::m_observers</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set of observers of MessageRequestObserverInterface. </p>

</div>
</div>
<a id="a057aa763160b1417dc31f93706fa5a8f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a057aa763160b1417dc31f93706fa5a8f">&#9670;&nbsp;</a></span>m_readers</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;std::shared_ptr&lt;<a class="el" href="structalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_message_request_1_1_named_reader.html">NamedReader</a>&gt; &gt; alexaClientSDK::avsCommon::avs::MessageRequest::m_readers</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The AttachmentReaders of the Attachments data to be sent to AVS. </p>

</div>
</div>
<a id="a23cd79d5ac89983f17b6c1d90a8942bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a23cd79d5ac89983f17b6c1d90a8942bf">&#9670;&nbsp;</a></span>m_uriPathExtension</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::avsCommon::avs::MessageRequest::m_uriPathExtension</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The path extension to be appended to the base URL when sending. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/AVS/include/AVSCommon/AVS/<a class="el" href="_message_request_8h_source.html">MessageRequest.h</a></li>
<li>/workplace/avs-device-sdk/AVSCommon/AVS/src/<a class="el" href="_message_request_8cpp.html">MessageRequest.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
